- UCA:
    Controller: Python Script
    Control Action: Send images to model

    Not Providing:
    - Reference: UCA-PSI-1
      Text: Python script does not provide images when there are new images available

    Providing:
    - Reference: UCA-PSI-100
      Text: Python script provides images which are old (> x seconds)

    - Reference: UCA-PSI-101
      Text: Python script provides images of poor quality (blurry, dark etc.)

    Too early, late or out of order:
    - Reference: UCA-PSI-1000
      Text: Python script provides images too late (> x seconds) after environment images have been received from GStreamer

- UCA:
    Controller: Python Script
    Control Action: Send Go cmd to GStreamer (GG)

    Not Providing:
    - Reference: UCA-GG-1
      Text: Python script does not provide a go cmd to start GStreamer when it is not running

    - Reference: UCA-GG-2
      Text: Python script does not provide a go cmd with a valid config when GStreamer's config is inaccurate

    Providing:
    - Reference: UCA-GG-100
      Text: Python script provides a go cmd with inaccurate config file to GStreamer

    - Reference: UCA-GG-101
      Text: Python script provides a go cmd when GStreamer is already running with a valid config

    Too early, late or out of order:
    - Reference: UCA-GG-1000
      Text: Python script provides a go cmd to GStreamer too late for the camera to send environment images within X seconds of systemd starting the Python script

    - Reference: UCA-GG-1001
      Text: Python script provides go cmd to GStreamer too late (> x seconds) after GStreamer has been inactive, or it is active with the wrong config

- UCA:
    Controller: Python Script
    Control Action: Send Motor Controls (MC)

    Not Providing:
    - Reference: UCA-MC-1
      Text: Python script does not provide motor control with reduced power (< P) when relative velocity and distance to an obstacle mean that a collision is imminent

    - Reference: UCA-MC-2
      Text: Python script does not provide motor control with power 0 when the vehicle is moving and it has reached the final destination

    - Reference: UCA-MC-3
      Text: Python script does not provide motor control with power 0 when a collision occurs

    - Reference: UCA-MC-4
      Text: Python script does not provide motor control with power > 0 when there is no obstacle, no faults, the vehicle has not reached destination and it is stationary

    - Reference: UCA-MC-5
      Text: Python script does not provide motor control with power 0 before program terminates

    - Reference: UCA-MC-6
      Text: Python script does not provide motor control with updated trajectory when there is an obstacle imminently in the current trajectory or a quicker direction to the destination

    Providing:
    - Reference: UCA-MC-100
      Text: Python script provides motor control with excessive power (> P) which will result in a relative velocity to an obstacle that will cause an imminent collision

    - Reference: UCA-MC-101
      Text: Python script provides motor control with power > 0 when the vehicle is at its final destination

    - Reference: UCA-MC-102
      Text: Python script provides motor control with power > 0 when a collision has occurred

    - Reference: UCA-MC-103
      Text: Python script provides motor control with power 0 when there is no obstacle in its path and the end has not been reached

    - Reference: UCA-MC-104
      Text: Python script provides motor control with power > 0 after it has given final power 0 command before program terminates

    - Reference: UCA-MC-105
      Text: Python script provides motor control with inaccurate updated trajectory that steers the vehicle towards collision or away from quickest route to the destination

    Too early, late or out of order:
    - Reference: UCA-MC-1000
      Text: Python script provides motor control too late (> X seconds) after relative velocity and distance to an obstacle mean that a collision is imminent

    - Reference: UCA-MC-1001
      Text: Python script provides motor control with power 0 too late (> X seconds after) when vehicle has reached the final destination

    - Reference: UCA-MC-1002
      Text: Python script provides motor control with power 0 too late (> X seconds after collision) when a collision occurs

    - Reference: UCA-MC-1003
      Text: Python script does not provide motor control < X seconds after last motor control was sent

    - Reference: UCA-MC-1004
      Text: Python script provides motrol control with updated trajectory too early when changing direction to avoid an obstacle

    - Reference: UCA-MC-1005
      Text: Python script provides motrol control with updated trajectory too late when changing direction to avoid an obstacle
